package b4a.example.labeltextfitting;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
        mostCurrent = this;
		if (processBA == null) {
			processBA = new anywheresoftware.b4a.ShellBA(this.getApplicationContext(), null, null, "b4a.example.labeltextfitting", "b4a.example.labeltextfitting.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.setActivityPaused(true);
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
        WaitForLayout wl = new WaitForLayout();
        if (anywheresoftware.b4a.objects.ServiceHelper.StarterHelper.startFromActivity(processBA, wl, true))
		    BA.handler.postDelayed(wl, 5);

	}
	static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example.labeltextfitting", "b4a.example.labeltextfitting.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.labeltextfitting.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEventFromUI(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeydown", this, new Object[] {keyCode, event}))
            return true;
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
        if (processBA.runHook("onkeyup", this, new Object[] {keyCode, event}))
            return true;
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null)
            return;
        if (this != mostCurrent)
			return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        if (mostCurrent != null)
            processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
            main mc = mostCurrent;
			if (mc == null || mc != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
            if (mc != mostCurrent)
                return;
		    processBA.raiseEvent(mc._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}
    public void onRequestPermissionsResult(int requestCode,
        String permissions[], int[] grantResults) {
        for (int i = 0;i < permissions.length;i++) {
            Object[] o = new Object[] {permissions[i], grantResults[i] == 0};
            processBA.raiseEventFromDifferentThread(null,null, 0, "activity_permissionresult", true, o);
        }
            
    }



public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}
public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}

private static BA killProgramHelper(BA ba) {
    if (ba == null)
        return null;
    anywheresoftware.b4a.BA.SharedProcessBA sharedProcessBA = ba.sharedProcessBA;
    if (sharedProcessBA == null || sharedProcessBA.activityBA == null)
        return null;
    return sharedProcessBA.activityBA.get();
}
public static void killProgram() {
     {
            Activity __a = null;
            if (main.previousOne != null) {
				__a = main.previousOne.get();
			}
            else {
                BA ba = killProgramHelper(main.mostCurrent == null ? null : main.mostCurrent.processBA);
                if (ba != null) __a = ba.activity;
            }
            if (__a != null)
				__a.finish();}

}
public anywheresoftware.b4a.keywords.Common __c = null;
public anywheresoftware.b4a.objects.LabelWrapper _label1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button1 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button2 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button3 = null;
public anywheresoftware.b4a.objects.ButtonWrapper _button4 = null;
public anywheresoftware.b4a.objects.StringUtils _stu = null;
public static void  _activity_create(boolean _firsttime) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_create", false))
	 {Debug.delegate(mostCurrent.activityBA, "activity_create", new Object[] {_firsttime}); return;}
ResumableSub_Activity_Create rsub = new ResumableSub_Activity_Create(null,_firsttime);
rsub.resume(processBA, null);
}
public static class ResumableSub_Activity_Create extends BA.ResumableSub {
public ResumableSub_Activity_Create(b4a.example.labeltextfitting.main parent,boolean _firsttime) {
this.parent = parent;
this._firsttime = _firsttime;
}
b4a.example.labeltextfitting.main parent;
boolean _firsttime;
String _txt = "";

@Override
public void resume(BA ba, Object[] result) throws Exception{
RDebugUtils.currentModule="main";

    while (true) {
        switch (state) {
            case -1:
return;

case 0:
//C
this.state = -1;
RDebugUtils.currentLine=131073;
 //BA.debugLineNum = 131073;BA.debugLine="Activity.LoadLayout(\"main\")";
parent.mostCurrent._activity.LoadLayout("main",mostCurrent.activityBA);
RDebugUtils.currentLine=131074;
 //BA.debugLineNum = 131074;BA.debugLine="Dim txt = \"This is the time for all good men to c";
_txt = "This is the time for all good men to come to the aid of their country";
RDebugUtils.currentLine=131075;
 //BA.debugLineNum = 131075;BA.debugLine="Label1.Text = txt";
parent.mostCurrent._label1.setText(BA.ObjectToCharSequence(_txt));
RDebugUtils.currentLine=131076;
 //BA.debugLineNum = 131076;BA.debugLine="Button1.Text = txt";
parent.mostCurrent._button1.setText(BA.ObjectToCharSequence(_txt));
RDebugUtils.currentLine=131077;
 //BA.debugLineNum = 131077;BA.debugLine="Button2.Text = \"normal\"";
parent.mostCurrent._button2.setText(BA.ObjectToCharSequence("normal"));
RDebugUtils.currentLine=131078;
 //BA.debugLineNum = 131078;BA.debugLine="Button3.Text = \"Too Much Much MuchToo Much Much M";
parent.mostCurrent._button3.setText(BA.ObjectToCharSequence("Too Much Much MuchToo Much Much MuchToo Much Much Much"));
RDebugUtils.currentLine=131079;
 //BA.debugLineNum = 131079;BA.debugLine="Button4.Text = \"hi\"";
parent.mostCurrent._button4.setText(BA.ObjectToCharSequence("hi"));
RDebugUtils.currentLine=131080;
 //BA.debugLineNum = 131080;BA.debugLine="SetAutoSizeBasedOnText(Label1)";
_setautosizebasedontext((anywheresoftware.b4a.objects.ConcreteViewWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.ConcreteViewWrapper(), (android.view.View)(parent.mostCurrent._label1.getObject())));
RDebugUtils.currentLine=131081;
 //BA.debugLineNum = 131081;BA.debugLine="SetAutoSizeBasedOnText(Button1)";
_setautosizebasedontext((anywheresoftware.b4a.objects.ConcreteViewWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.ConcreteViewWrapper(), (android.view.View)(parent.mostCurrent._button1.getObject())));
RDebugUtils.currentLine=131082;
 //BA.debugLineNum = 131082;BA.debugLine="SetAutoSizeBasedOnText(Button2)";
_setautosizebasedontext((anywheresoftware.b4a.objects.ConcreteViewWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.ConcreteViewWrapper(), (android.view.View)(parent.mostCurrent._button2.getObject())));
RDebugUtils.currentLine=131083;
 //BA.debugLineNum = 131083;BA.debugLine="SetAutoSizeBasedOnText(Button3)";
_setautosizebasedontext((anywheresoftware.b4a.objects.ConcreteViewWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.ConcreteViewWrapper(), (android.view.View)(parent.mostCurrent._button3.getObject())));
RDebugUtils.currentLine=131084;
 //BA.debugLineNum = 131084;BA.debugLine="SetAutoSizeBasedOnText(Button4)";
_setautosizebasedontext((anywheresoftware.b4a.objects.ConcreteViewWrapper) anywheresoftware.b4a.AbsObjectWrapper.ConvertToWrapper(new anywheresoftware.b4a.objects.ConcreteViewWrapper(), (android.view.View)(parent.mostCurrent._button4.getObject())));
RDebugUtils.currentLine=131086;
 //BA.debugLineNum = 131086;BA.debugLine="Sleep(5000)";
anywheresoftware.b4a.keywords.Common.Sleep(mostCurrent.activityBA,new anywheresoftware.b4a.shell.DebugResumableSub.DelegatableResumableSub(this, "main", "activity_create"),(int) (5000));
this.state = 1;
return;
case 1:
//C
this.state = -1;
;
RDebugUtils.currentLine=131088;
 //BA.debugLineNum = 131088;BA.debugLine="SetTextSize(Label1, txt)";
_settextsize(parent.mostCurrent._label1,_txt);
RDebugUtils.currentLine=131089;
 //BA.debugLineNum = 131089;BA.debugLine="SetTextSizeButton(Button1, txt)";
_settextsizebutton(parent.mostCurrent._button1,_txt);
RDebugUtils.currentLine=131090;
 //BA.debugLineNum = 131090;BA.debugLine="SetTextSizeButton(Button2, \"normal\")";
_settextsizebutton(parent.mostCurrent._button2,"normal");
RDebugUtils.currentLine=131091;
 //BA.debugLineNum = 131091;BA.debugLine="SetTextSizeButton(Button3, \"Too Much Much MuchToo";
_settextsizebutton(parent.mostCurrent._button3,"Too Much Much MuchToo Much Much MuchToo Much Much Much");
RDebugUtils.currentLine=131092;
 //BA.debugLineNum = 131092;BA.debugLine="SetTextSizeButton(Button4, \"hi\")";
_settextsizebutton(parent.mostCurrent._button4,"hi");
RDebugUtils.currentLine=131094;
 //BA.debugLineNum = 131094;BA.debugLine="End Sub";
if (true) break;

            }
        }
    }
}
public static String  _setautosizebasedontext(anywheresoftware.b4a.objects.ConcreteViewWrapper _v) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "setautosizebasedontext", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "setautosizebasedontext", new Object[] {_v}));}
anywheresoftware.b4j.object.JavaObject _jo = null;
RDebugUtils.currentLine=458752;
 //BA.debugLineNum = 458752;BA.debugLine="Sub SetAutoSizeBasedOnText(v As View)";
RDebugUtils.currentLine=458754;
 //BA.debugLineNum = 458754;BA.debugLine="Dim jo As JavaObject";
_jo = new anywheresoftware.b4j.object.JavaObject();
RDebugUtils.currentLine=458755;
 //BA.debugLineNum = 458755;BA.debugLine="jo.InitializeStatic(\"android.support.v4.widget.Te";
_jo.InitializeStatic("android.support.v4.widget.TextViewCompat");
RDebugUtils.currentLine=458756;
 //BA.debugLineNum = 458756;BA.debugLine="jo.RunMethod(\"setAutoSizeTextTypeWithDefaults\", A";
_jo.RunMethod("setAutoSizeTextTypeWithDefaults",new Object[]{(Object)(_v.getObject()),(Object)(1)});
RDebugUtils.currentLine=458757;
 //BA.debugLineNum = 458757;BA.debugLine="End Sub";
return "";
}
public static String  _settextsize(anywheresoftware.b4a.objects.LabelWrapper _lbl,String _txt) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "settextsize", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "settextsize", new Object[] {_lbl,_txt}));}
float _dt = 0f;
float _limit = 0f;
int _h = 0;
RDebugUtils.currentLine=327680;
 //BA.debugLineNum = 327680;BA.debugLine="Sub SetTextSize(lbl As Label, txt As String)";
RDebugUtils.currentLine=327682;
 //BA.debugLineNum = 327682;BA.debugLine="Dim dt As Float";
_dt = 0f;
RDebugUtils.currentLine=327683;
 //BA.debugLineNum = 327683;BA.debugLine="Dim limit = 0.5 As Float";
_limit = (float) (0.5);
RDebugUtils.currentLine=327684;
 //BA.debugLineNum = 327684;BA.debugLine="Dim h As Int";
_h = 0;
RDebugUtils.currentLine=327685;
 //BA.debugLineNum = 327685;BA.debugLine="lbl.Text = txt";
_lbl.setText(BA.ObjectToCharSequence(_txt));
RDebugUtils.currentLine=327686;
 //BA.debugLineNum = 327686;BA.debugLine="lbl.TextSize = 72";
_lbl.setTextSize((float) (72));
RDebugUtils.currentLine=327687;
 //BA.debugLineNum = 327687;BA.debugLine="dt = lbl.TextSize";
_dt = _lbl.getTextSize();
RDebugUtils.currentLine=327688;
 //BA.debugLineNum = 327688;BA.debugLine="h = stu.MeasureMultilineTextHeight(lbl, txt)";
_h = mostCurrent._stu.MeasureMultilineTextHeight((android.widget.TextView)(_lbl.getObject()),BA.ObjectToCharSequence(_txt));
RDebugUtils.currentLine=327689;
 //BA.debugLineNum = 327689;BA.debugLine="Do While dt > limit Or h > lbl.Height";
while (_dt>_limit || _h>_lbl.getHeight()) {
RDebugUtils.currentLine=327690;
 //BA.debugLineNum = 327690;BA.debugLine="dt = dt / 2";
_dt = (float) (_dt/(double)2);
RDebugUtils.currentLine=327691;
 //BA.debugLineNum = 327691;BA.debugLine="h = stu.MeasureMultilineTextHeight(lbl, txt)";
_h = mostCurrent._stu.MeasureMultilineTextHeight((android.widget.TextView)(_lbl.getObject()),BA.ObjectToCharSequence(_txt));
RDebugUtils.currentLine=327692;
 //BA.debugLineNum = 327692;BA.debugLine="If h > lbl.Height Then";
if (_h>_lbl.getHeight()) { 
RDebugUtils.currentLine=327693;
 //BA.debugLineNum = 327693;BA.debugLine="lbl.TextSize = lbl.TextSize - dt";
_lbl.setTextSize((float) (_lbl.getTextSize()-_dt));
 }else {
RDebugUtils.currentLine=327695;
 //BA.debugLineNum = 327695;BA.debugLine="lbl.TextSize = lbl.TextSize + dt";
_lbl.setTextSize((float) (_lbl.getTextSize()+_dt));
 };
 }
;
RDebugUtils.currentLine=327698;
 //BA.debugLineNum = 327698;BA.debugLine="End Sub";
return "";
}
public static String  _settextsizebutton(anywheresoftware.b4a.objects.ButtonWrapper _btn,String _txt) throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "settextsizebutton", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "settextsizebutton", new Object[] {_btn,_txt}));}
float _dt = 0f;
float _limit = 0f;
int _h = 0;
RDebugUtils.currentLine=393216;
 //BA.debugLineNum = 393216;BA.debugLine="Sub SetTextSizeButton(btn As Button, txt As String";
RDebugUtils.currentLine=393217;
 //BA.debugLineNum = 393217;BA.debugLine="Dim dt As Float";
_dt = 0f;
RDebugUtils.currentLine=393218;
 //BA.debugLineNum = 393218;BA.debugLine="Dim limit = 0.5 As Float";
_limit = (float) (0.5);
RDebugUtils.currentLine=393219;
 //BA.debugLineNum = 393219;BA.debugLine="Dim h As Int";
_h = 0;
RDebugUtils.currentLine=393220;
 //BA.debugLineNum = 393220;BA.debugLine="btn.Text = txt";
_btn.setText(BA.ObjectToCharSequence(_txt));
RDebugUtils.currentLine=393221;
 //BA.debugLineNum = 393221;BA.debugLine="btn.TextSize = 72";
_btn.setTextSize((float) (72));
RDebugUtils.currentLine=393222;
 //BA.debugLineNum = 393222;BA.debugLine="dt = btn.TextSize";
_dt = _btn.getTextSize();
RDebugUtils.currentLine=393223;
 //BA.debugLineNum = 393223;BA.debugLine="h = stu.MeasureMultilineTextHeight(btn, txt)";
_h = mostCurrent._stu.MeasureMultilineTextHeight((android.widget.TextView)(_btn.getObject()),BA.ObjectToCharSequence(_txt));
RDebugUtils.currentLine=393224;
 //BA.debugLineNum = 393224;BA.debugLine="Do While dt > limit Or h > btn.Height";
while (_dt>_limit || _h>_btn.getHeight()) {
RDebugUtils.currentLine=393225;
 //BA.debugLineNum = 393225;BA.debugLine="dt = dt / 2";
_dt = (float) (_dt/(double)2);
RDebugUtils.currentLine=393226;
 //BA.debugLineNum = 393226;BA.debugLine="h = stu.MeasureMultilineTextHeight(btn, txt)";
_h = mostCurrent._stu.MeasureMultilineTextHeight((android.widget.TextView)(_btn.getObject()),BA.ObjectToCharSequence(_txt));
RDebugUtils.currentLine=393227;
 //BA.debugLineNum = 393227;BA.debugLine="If h > btn.Height Then";
if (_h>_btn.getHeight()) { 
RDebugUtils.currentLine=393228;
 //BA.debugLineNum = 393228;BA.debugLine="btn.TextSize = btn.TextSize - dt";
_btn.setTextSize((float) (_btn.getTextSize()-_dt));
 }else {
RDebugUtils.currentLine=393230;
 //BA.debugLineNum = 393230;BA.debugLine="btn.TextSize = btn.TextSize + dt";
_btn.setTextSize((float) (_btn.getTextSize()+_dt));
 };
 }
;
RDebugUtils.currentLine=393233;
 //BA.debugLineNum = 393233;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
RDebugUtils.currentModule="main";
RDebugUtils.currentLine=262144;
 //BA.debugLineNum = 262144;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
RDebugUtils.currentLine=262146;
 //BA.debugLineNum = 262146;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
RDebugUtils.currentModule="main";
if (Debug.shouldDelegate(mostCurrent.activityBA, "activity_resume", false))
	 {return ((String) Debug.delegate(mostCurrent.activityBA, "activity_resume", null));}
RDebugUtils.currentLine=196608;
 //BA.debugLineNum = 196608;BA.debugLine="Sub Activity_Resume";
RDebugUtils.currentLine=196610;
 //BA.debugLineNum = 196610;BA.debugLine="End Sub";
return "";
}
}